#include <Stepper.h>
#define STEPS 200
#define BUTTON_PIN 4
#define MAX_TRANSLATE 420
#define DELAY 20
 
// create an instance of the stepper class, specifying
// the number of steps of the motor and the pins it's
// attached to
Stepper translation(STEPS, 10, 9, 8, 7);
Stepper rotation(STEPS, 0, 1, 2, 3);

 
void setup()
{
  // set the speed of the motor to 30 RPMs
  translation.setSpeed(30);
  rotation.setSpeed(30);
  
  pinMode(BUTTON_PIN, INPUT_PULLUP);

  // Find home
  int button_state = digitalRead(BUTTON_PIN); // 1 means nothing, 0 means pressed
  while (button_state) {
    translation.step(-1);
    button_state = digitalRead(BUTTON_PIN);
  }
}

int t_steps = 840;
int d = DELAY;

void loop()
{
  rotation.step(1);

  if (d == DELAY){
    if (t_steps > 420){
      translation.step(1);
    } else {
      translation.step(-1);
    }
  
    if (t_steps == 0){
      t_steps = 840;
    }
    t_steps -= 1; 
    d = 0;
  }
  d += 1;
}
